/*
 * Copyright (C) 2010 Yury P. Fedorchenko
 * yuryfdr@users.sf.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */

package chgame;

class Checker{
  int x,y;
  boolean isWhite,isKing;
};

public class Checkers{

  GameInternal board;
  boolean whotrn;
  public boolean isWite;
  //int game_type;
  public Checkers(boolean white) {
    isWite = white;
    whotrn = true;
    //game_type=1;
    board = new RCheckers(white,2);
  }

  public int winner() {
    return board.winner;
  }

  public boolean gameOver() {
    return board.game_over;
  }
  public int getSkill(){
    return board.levelmax;
  }
  public void setSkill(int i){
    board.levelmax=i;
  }
  public int item(int x,int y){
    int itm = x / 2 + 4 * y;
    return board.item(itm);
  }
  public int type(){ return board.type();}
  public void type(int tp){
    if(tp==0)board = new ECheckers(whotrn,board.levelmax);
    else board=new RCheckers(whotrn,board.levelmax);
  }
  public void newGame(boolean white){
    whotrn = true;
    board.newGame(white, board.levelmax);
  }
   public boolean move(int xf,int yf, int X, int Y, javax.microedition.lcdui.Canvas cnv) {
    int from = xf / 2 + 4 * yf;
    int to = X / 2 + 4 * Y;
    if (whotrn) {
      if (board.go1(from, to)) {
        cnv.repaint();
        cnv.serviceRepaints();
        whotrn = false;
        if(board.check_win(whotrn)){
        }
        if(!gameOver()){//          System.out.println("before go2");
          board.go2();//          System.out.println("after go2");
          whotrn = true;
          if(board.check_win(whotrn)){
          }
        }
        return true;
      }
    }
    if (!whotrn) {
        if (board.go2_human(from, to)) {
          whotrn = true;
          if(board.check_win(whotrn)){
          }
          return true;
        }
    }
    return false;
  }


  //
  
}
